#!/usr/bin/python
# -*- coding: UTF-8 -*-
import gi
import os

gi.require_version('Gtk', '3.0')
from gi.repository import Gtk

# 继承Gtk.ListBoxRow
#class ListBoxRowWithData(Gtk.ListBoxRow):
#    def __init__(self, data):
#        super(Gtk.ListBoxRow, self).__init__()
#        self.data = data
#        self.add(Gtk.Label(data))


class ListBoxWindow(Gtk.Window):
    def __init__(self):
        Gtk.Window.__init__(self, title="方德系统密码复杂度选择")
        # 设置窗口宽度
        self.set_border_width(10)
        self.set_default_size(400, 100)
        self.act = False

        # 定义一个盒子桥梁 | 垂直排列 | 间隔为6
        box_outer = Gtk.Box(orientation=Gtk.Orientation.VERTICAL, spacing=6)
        self.add(box_outer)

        # 定义一个list容器
        listbox = Gtk.ListBox()
        listbox.set_selection_mode(Gtk.SelectionMode.NONE)
        box_outer.pack_start(listbox, True, True, 0)

        # 定义一个行箱子
        row = Gtk.ListBoxRow()
        # 定义一个原子盒子 | 水平装产品
        box1 = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL, spacing=50)

        # 定义标签
        internal_time_label = Gtk.Label("是否使用复杂密码", xalign=0)
        # 定义一个开关按钮
        # switch = Gtk.Switch()
        # switch.props.valign = Gtk.Align.CENTER
        button1 = Gtk.CheckButton()
        button1.connect("toggled", self.on_checkbutton_toggled)

        # 装箱
        box1.pack_start(internal_time_label, True, True, 0)
        # box1.pack_start(switch, False, True, 0)
        box1.pack_start(button1, True, True, 0)
        row.add(box1)
        listbox.add(row)
        # 在定义一个ListBox
        listbox_2 = Gtk.ListBox()
        self.entry = Gtk.Entry()
        listbox_2.add(self.entry)
        fp = open("/usr/bin/nfs-password-complex-control/status", 'r')
        readinfo = fp.readline()
        fp.close()
        print readinfo
        if "complex" == readinfo:
            self.entry.set_text("当前系统中密码复杂度：高。")
        else:
            self.entry.set_text("当前系统中密码复杂度：低。")
            

        button2 = Gtk.Button("修改密码复杂度配置开始执行")
        button2.connect("clicked", self.on_button_clicked)
        listbox_2.add(button2)
        box_outer.pack_start(listbox_2, True, True, 0)

    def on_checkbutton_toggled(self, button1):
        self.act = button1.get_active()
        
    def on_button_clicked(self, button2):
        if self.act:
            os.system("cp -f /usr/bin/nfs-password-complex-control/system-auth-ac.complex /etc/pam.d/system-auth-ac")
            os.system("cp -f /usr/bin/nfs-password-complex-control/Linux-PAM.mo.complex /usr/share/locale/zh_CN/LC_MESSAGES/Linux-PAM.mo")
            fp = open("/usr/bin/nfs-password-complex-control/status", 'w')
            fp.write("complex")
            fp.flush()
            fp.close()
            self.entry.set_text("当前系统中密码复杂度：高。")
        else:
            os.system("cp -f /usr/bin/nfs-password-complex-control/system-auth-ac.simple  /etc/pam.d/system-auth-ac")
            os.system("cp -f /usr/bin/nfs-password-complex-control/Linux-PAM.mo.simple /usr/share/locale/zh_CN/LC_MESSAGES/Linux-PAM.mo")
            fp = open("/usr/bin/nfs-password-complex-control/status", 'w')
            fp.write("simple")
            fp.flush()
            fp.close()
            self.entry.set_text("当前系统中密码复杂度：低。")

if __name__ == '__main__':
    win = ListBoxWindow()
    win.connect("delete-event", Gtk.main_quit)
    win.show_all()
    Gtk.main()
